package game.monstersandwizards;

import java.util.Arrays;

public class Game {

  public static void arrange(Victim[] tab) {
    boolean test;
    do {
      test = true;
      for (int i = 0; i < tab.length - 1; i++) {
        if((tab[i].exist()) && (!tab[i + 1].exist())) {
          Victim temp = tab[i];
          tab[i] = tab[i + 1];
          tab[i + 1] = temp;
          test = false;
        }
      }
    } while (!test);
  }

  public static void main(String[] args) {
    int n = 20;
    Victim[] tab = new Victim[n];
    int j = 0;
    while(j < tab.length) {
      int test = (int) (Math.random() * 4);
      switch (test) {
        case 0:
          tab[j] = new Monster("Mo" + j, (int) (Math.random() * 100));
          j++;
          break;
        case 1:
          tab[j] = new Wizard("Wi" + j, (int) (Math.random() * 100));
          j++;
          break;
        case 2:
          tab[j] = new Warlock("Wa" + j, (int) (Math.random() * 100));
          j++;
          break;
        case 3:
          if(Math.random() < 0.5) {
            tab[j] = new GardenGnome((int) (Math.random() * 100));
          } else {
            tab[j] = new Gnome((int) (Math.random() * 100));
          }
          j++;
          break;
      }
    }
    int alive = tab.length;
    int i = 200;
    while((alive > 1) && (i > 0)) {
      int i1 = (int) (Math.random() * alive);
      int i2 = (int) (Math.random() * alive);
      while(i1 == i2) {
        i2 = (int) (Math.random() * alive);
      }
      if(tab[i1] instanceof Person) {
        Person p = (Person) tab[i1];
        p.attack(tab[i2]);
        System.out.println(tab[i1].getName() + " attacks " + tab[i2].getName() + "\n");
        if(p.isDead()) {
          alive--;
        }
        if(tab[i2].exist()) {
          alive--;
        }
        arrange(tab);
        i--;
      }
    }
    if(i > 0) {
      System.out.println("The winner is " + tab[0].getName() + "\n" + tab[0]);
    } else {
      System.out.println("Draw. Battlefield state:\n"+Arrays.toString(tab));
    }
  }
}
