package game.monstersandwizards;

public class GardenGnome implements Victim {

  private int solidity;

  /**
   * Construct a garden gnome.
   * @param s the garden gnome's solidity
   */
  public GardenGnome(int s){
    solidity = s;
  }

  /**
   * Renturns the value of the garden gnome's solidity
   * @return the value of solidity
   */
  public int getSolidity(){
    return solidity;
  }

  public String getName() {
    return "Garden Gnome";
  }

  public int beingHit(int hit) {
    if(hit>solidity){
      int tmp = solidity;
      solidity=0;
      return tmp;
    } else {
      return hit;
    }
  }

  public int beingBewitched(int hit) {
    return 1;
  }

  @Override
  public String toString(){
    return "I am a garden gnome and my solidity is "+solidity;
  }

  public boolean exist() {
    return !(solidity==0);
  }
}
